﻿@using DevExpress.Web;
@using DevExpress.Web.Mvc;
@using System.Web.UI.WebControls;
@using Portal.Controllers;
@using Portal.Models.SupplierPerformance;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.Credential;
@using Portal.Models.Globals;
@using Portal.Models.SupplierPerformance;

@Html.DevExpress().GridView(
    Grv => {
        Grv.Name = "GridSPWorkAbility";
        Grv.KeyFieldName = "PROD_MONTH; SUPPLIER_CD; PART_NO";
        Grv.CallbackRouteValues = new { Controller = "SupplierPerformance", Action = "ReloadGridWorkAbilityDetail" };
        Grv.ClientSideEvents.BeginCallback = "OnBeginCallback";
        Grv.ClientSideEvents.EndCallback = "OnEndCallback";
        Grv.Width = Unit.Percentage(100);
        Grv.Styles.Header.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        Grv.SettingsBehavior.AllowDragDrop = false;
        
        Grv.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
        //setting.Settings.VerticalScrollBarMode = ScrollBarMode.Visible;

        Grv.SettingsEditing.Mode = GridViewEditingMode.Inline;
        
        Grv.SettingsPager.PageSizeItemSettings.Visible = true;
        Grv.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
        Grv.SettingsPager.PageSizeItemSettings.Caption = "Page Size";

        Grv.CommandColumn.Visible = true;
        Grv.CommandColumn.ClearFilterButton.Visible = true;
        Grv.CommandColumn.ShowSelectCheckbox = true;
        Grv.CommandColumn.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        Grv.CommandColumn.ShowSelectCheckbox = true;
        Grv.CommandColumn.Width = Unit.Pixel(42);
        Grv.CommandColumn.SetHeaderTemplateContent(
            c =>
            {
                Html.DevExpress().CheckBox(
                        chckBox =>
                        {
                            chckBox.Name = "ChkBoxWorkAbility";
                            chckBox.Properties.ClientSideEvents.CheckedChanged = "OnCheckAll";
                        }
                    ).Render();
            });
        
        Grv.Columns.Add(
            col => {
                col.Name = "ProductionMonth";
                col.Caption = "Production<br>Month";
                col.FieldName = "PROD_MONTH";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);
                
                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdSuppCode = col.PropertiesEdit as ComboBoxProperties;
                cmdSuppCode.DropDownStyle = DropDownStyle.DropDown;
                List<SPMonthYear> pm = Model.GetModel<List<SPMonthYear>>();
                if (pm.Count() > 0)
                    pm.ForEach(s => cmdSuppCode.Items.Add(s.MonthYear));  
            });

        Grv.Columns.Add(
            col => {
                col.Name = "SupplierCode";
                col.Caption = "Supplier<br>Code";
                col.FieldName = "SUPPLIER_CD";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);
                                
                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                var cmdSuppCode = col.PropertiesEdit as ComboBoxProperties;
                cmdSuppCode.DropDownStyle = DropDownStyle.DropDown;
                List<SupplierICS> Supplier = Model.GetModel<List<SupplierICS>>();
                if (Supplier.Count() > 0)
                    Supplier.ForEach(s => cmdSuppCode.Items.Add(s.SUPP_CD));  
            });
        
        Grv.Columns.Add(
            col => {
                col.Name = "SupplierName";
                col.Caption = "Supplier Name";
                col.FieldName = "SUPPLIER_NAME";
                col.Width = Unit.Pixel(180);
            });

        Grv.Columns.Add(
            col => {
                col.Name = "PartNo";
                col.Caption = "Part No";
                col.FieldName = "PART_NO";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);
            });

        Grv.Columns.Add(
            col => {
                col.Name = "PartName";
                col.Caption = "Part Name";
                col.FieldName = "PART_NAME";
                col.Width = Unit.Pixel(180);
            });

        Grv.Columns.Add(
            col => {
                col.Name = "QtyReceive";
                col.Caption = "Qty<br>Receive";
                col.FieldName = "QTY_RECEIVE";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
                col.Width = Unit.Pixel(60);
                col.PropertiesEdit.DisplayFormatString = "##,##";
            });
        //ADD BY ALIRA.AGI 2015-05-26
        Grv.Columns.Add(
            col =>
            {
                col.Name = "NGDelivery";
                col.Caption = "NG Delivery";
                col.FieldName = "NG_DELIVERY";
                col.Width = Unit.Pixel(240);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "DescDelivery";
                col.Caption = "Desc<br>Delivery";
                col.FieldName = "DESC_DELIVERY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(200);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "Time3";
                col.Caption = "Time";
                col.FieldName = "TIME3";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(200);
                col.PropertiesEdit.DisplayFormatString = "##:##:##";
            });
        //END ADD
        
        Grv.Columns.Add(
            col => {
                col.Name = "NGQuality";
                col.Caption = "NG Quality";
                col.FieldName = "NG_QUALITY";
                col.Width = Unit.Pixel(240);
            });

        Grv.Columns.Add(
            col => {
                col.Name = "DescQuality";
                col.Caption = "Desc<br>Quality";
                col.FieldName = "DESC_QUALITY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(200);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "Time1";
                col.Caption = "Time";
                col.FieldName = "TIME1";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(200);
                col.PropertiesEdit.DisplayFormatString = "##:##:##";
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "NGWorkAbility";
                col.Caption = "NG<br>Workability";
                col.FieldName = "NG_WORKABILITY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(200);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "DescWorkAbility";
                col.Caption = "Desc<br>Workability";
                col.FieldName = "DESC_WORKABILITY";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(200);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "Time2";
                col.Caption = "Time";
                col.FieldName = "TIME2";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(200);
                col.PropertiesEdit.DisplayFormatString = "##:##:##";
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "CreatedBy";
                col.Caption = "Created By";
                col.FieldName = "CREATED_BY";
                col.Width = Unit.Pixel(80);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "CreatedDate";
                col.Caption = "Created Date";
                col.FieldName = "CREATED_DT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);
                
                col.ColumnType = MVCxGridViewColumnType.DateEdit;
                var deProperties = col.PropertiesEdit as DateEditProperties;
                deProperties.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
            });
        
        Grv.Columns.Add(
            col =>
            {
                col.Name = "ChangedBy";
                col.Caption = "ChangedBy";
                col.FieldName = "CHANGED_BY";
                col.Width = Unit.Pixel(80);
            });

        Grv.Columns.Add(
            col =>
            {
                col.Name = "ChangedDate";
                col.Caption = "Changed Date";
                col.FieldName = "CHANGED_DT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);
                
                col.ColumnType = MVCxGridViewColumnType.DateEdit;
                var deProperties = col.PropertiesEdit as DateEditProperties;
                deProperties.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
            });
        
        
        ///set value for call from javascript
        Grv.CustomJSProperties = (s, e) =>
        {
            MVCxGridView grid = (MVCxGridView)s;

            //Changed By FID.Reggy
            int StartIndex = 0;
            //int StartIndex = grid.PageIndex * grid.SettingsPager.PageSize;
            int EndIndex = Model.GetModel<List<SPWorkAbility>>() != null ? Model.GetModel<List<SPWorkAbility>>().Count :
                           Math.Min(grid.VisibleRowCount, StartIndex + grid.SettingsPager.PageSize);
            //int EndIndex = Math.Min(grid.VisibleRowCount, StartIndex + grid.SettingsPager.PageSize);

            object[] ProductionMonth = new object[EndIndex - StartIndex];
            object[] SupplierCode = new object[EndIndex - StartIndex];
            object[] PartNo = new object[EndIndex - StartIndex];
            object[] QtyReceive = new object[EndIndex - StartIndex];
            object[] NGQuality = new object[EndIndex - StartIndex];
            object[] DescQuality = new object[EndIndex - StartIndex];
            object[] Time1 = new object[EndIndex - StartIndex];
            object[] NGWorkAbility = new object[EndIndex - StartIndex];
            object[] DescWorkAbility = new object[EndIndex - StartIndex];
            object[] Time2 = new object[EndIndex - StartIndex];
            //add by alira.agi 2015-05-26
            object[] NGDelivery = new object[EndIndex - StartIndex];
            object[] DescDelivery = new object[EndIndex - StartIndex];
            object[] Time3 = new object[EndIndex - StartIndex];

            for (int i = StartIndex; i < EndIndex; i++)
            {
                ProductionMonth[i - StartIndex] = grid.GetRowValues(i, "PROD_MONTH");
                SupplierCode[i - StartIndex] = grid.GetRowValues(i, "SUPPLIER_CD");
                PartNo[i - StartIndex] = grid.GetRowValues(i, "PART_NO");
                QtyReceive[i - StartIndex] = grid.GetRowValues(i, "QTY_RECEIVE");
                NGQuality[i - StartIndex] = grid.GetRowValues(i, "NG_QUALITY");
                DescQuality[i - StartIndex] = grid.GetRowValues(i, "DESC_QUALITY");
                Time1[i - StartIndex] = grid.GetRowValues(i, "TIME1");
                NGWorkAbility[i - StartIndex] = grid.GetRowValues(i, "NG_WORKABILITY");
                DescWorkAbility[i - StartIndex] = grid.GetRowValues(i, "DESC_WORKABILITY");
                Time2[i - StartIndex] = grid.GetRowValues(i, "TIME2");
                //add by alira.agi 2015-05-26
                NGDelivery[i - StartIndex] = grid.GetRowValues(i, "NG_DELIVERY");
                DescDelivery[i - StartIndex] = grid.GetRowValues(i, "DESC_DELIVERY");
                Time3[i - StartIndex] = grid.GetRowValues(i, "TIME3");
            }

            e.Properties["cpProductionMonth"] = ProductionMonth;
            e.Properties["cpSupplierCode"] = SupplierCode;
            e.Properties["cpPartNo"] = PartNo;
            e.Properties["cpQtyReceive"] = QtyReceive;
            e.Properties["cpNGQuality"] = NGQuality;
            e.Properties["cpDescQuality"] = DescQuality;
            e.Properties["cpTime1"] = Time1;
            e.Properties["cpNGWorkAbility"] = NGWorkAbility;
            e.Properties["cpDescWorkAbility"] = DescWorkAbility;
            e.Properties["cpTime2"] = Time2;
            //add by alira.agi 2015-05-26
            e.Properties["cpNGDelivery"] = NGDelivery;
            e.Properties["cpDescDelivery"] = DescDelivery;
            e.Properties["cpTime3"] = Time3;

            grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
        };
        
                
        ///set gridview when button on clicked
        Grv.CommandButtonInitialize = (object sender, ASPxGridViewCommandButtonEventArgs e) =>
        {
            string IsEditRow = Request.Params["IsEditRow"];
            MVCxGridView gv = (MVCxGridView)sender;

            ///set visibility filter row
            if (IsEditRow == "1" || IsEditRow == "2")
            {
                gv.Settings.ShowFilterRow = false;
                gv.Settings.ShowFilterRowMenu = false;
            }
            else
            {
                gv.Settings.ShowFilterRow = true;
                gv.Settings.ShowFilterRowMenu = true;
            }

            ///Disable checkbox when grid is editing
            if (e.ButtonType == ColumnCommandButtonType.SelectCheckbox)
            {
                if (IsEditRow == "1" || IsEditRow == "2")
                    e.Enabled = false;
            }

            ///hide default button update and cancel on gridview when row is editing
            if (e.ButtonType == ColumnCommandButtonType.Update)
                e.Visible = false;

            if (e.ButtonType == ColumnCommandButtonType.Cancel)
                e.Visible = false;
        };
        
        ///disabled keyfield when grid is editing
        Grv.CellEditorInitialize = (object sender, ASPxGridViewEditorEventArgs e) => {
            MVCxGridView gv = (MVCxGridView)sender;
            string IsEditRow = Request.Params["IsEditRow"];

            if (e.Column.FieldName == "PROD_MONTH")
            {   
                if(IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }   
            }

            if (e.Column.FieldName == "SUPPLIER_CD")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }

            if (e.Column.FieldName == "PART_NO")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }

            if (e.Column.FieldName == "RECEIVING_AREA")
                if (IsEditRow == "1")
                    e.Editor.Enabled = gv.IsNewRowEditing;
                else if (IsEditRow == "2")
                {
                    e.Editor.Enabled = gv.IsNewRowEditing;
                    e.Editor.Visible = !gv.IsNewRowEditing;
                }   
            
            if (e.Column.FieldName == "SUPPLIER_NAME")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "PART_NAME")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CREATED_BY")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CREATED_DT")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CHANGED_BY")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }

            if (e.Column.FieldName == "CHANGED_DT")
            {
                e.Editor.Enabled = gv.IsNewRowEditing;
                e.Editor.Visible = !gv.IsNewRowEditing;
            }
        };
    }).Bind(Model.GetModel<List<SPWorkAbility>>()).GetHtml()